<template>
    <div>
        <b-tabs v-if="hasItemsToDisplay">
            <b-tab title="Successful">
                <table-test-result v-if="successfulItems.length > 0" :items="successfulItems" :limit="tableLimit"></table-test-result>
                <b-alert v-else show variant="info">
                    There are no results to show
                </b-alert>
            </b-tab>
            <b-tab title="Corrected">
                <table-test-result v-if="correctedItems.length > 0" :items="correctedItems" :limit="tableLimit"></table-test-result>
                <b-alert v-else show variant="info">
                    There are no results to show
                </b-alert>
            </b-tab>
            <b-tab title="Failure">
                <table-test-result v-if="failureItems.length > 0" :items="failureItems" hide-phone-number-col></table-test-result>
                <b-alert v-else show variant="info">
                    There are no results to show
                </b-alert>
            </b-tab>
        </b-tabs>
        <div v-else>
            <b-alert show variant="note">
                {{noItemsText}}
            </b-alert>
        </div>
    </div>
</template>

<script>
import _ from 'lodash';
import TableTestResult from './TableTestResult.vue';

export default {
    name: 'PhoneNumberResultDisplayer',
    components: {
        TableTestResult
    },
    props: {
        successfulItems: {
            type: Array,
            default: () => [],
        },
        correctedItems: {
            type: Array,
            default: () => [],
        },
        failureItems: {
            type: Array,
            default: () => [],
        },
        noItemsText: {
            type: String,
            default: 'There are no items to show'
        },
        limitResults: {
            type:Number,
            default: null
        }
    },
    computed: {
        tableLimit() {
            return typeof this.limitResults === 'number' && this.limitResults > 0 ? this.limitResults : -1;
        },
        hasItemsToDisplay() {
            return !_.isEmpty(this.successfulItems) ||
                   !_.isEmpty(this.correctedItems) ||
                   !_.isEmpty(this.failureItems);
        },
    }
};
</script>

<style>
</style>